<html>
<head>
<title>RManNotes: Stochastic Patterns: Turbulence</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="stoch_patterns.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="noise.html">previous</a>
|
<a href="pure.html">next</a>
|
<a href="index.html">stochastic patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1>Turbulence</h1>

<p>
A commonly used mechanism in stochastic patterns is <i>turbulence</i>.
Turbulence is created by summing multiple 
<a href="noise.html">noise functions</a> with varying amplitude and 
frequency. Usually, we make the amplitude inversely proportional to 
the frequency which provides a <i>fractal</i> or <i>1/f power spectrum</i>
<a href="../references.html">[Perlin85][Ebert94]</a>. 
The final result is a stochastic function which <i>appears</i> turbulent.
</p>

<p align=center><a href="turb512.jpg"><img src="turb128.gif"></a><br>
turbulence<br>
<a href="turb.sl">turb.sl</a>,
<a href="gcturb.sl">gcturb.sl</a>
</p>

<p>
There are many ways to "compute turbulence." The code fragment below 
is probably the simplest form where a fixed number of <i>octaves</i>
of noise (<i>maxfreq</i>) are used. We use 
<a href="noise.html#snoise">signed noise</a> and <code>abs</code> to
create discontinuities. This also doubles the number of peaks. 
</p>

<pre>
  turb = 0;
  for (f = 1; f < maxfreq; f *= 2) 
    turb += abs(snoise(P * f)) / f;
</pre>

<p>
Note: Better results may be achieved by scaling <i>f</i> by a value 
slightly greater or less than 2 (e.g. 2.17) to avoid alignment
of lattice points between the individual noise octaves
<a href="../references.html">[Ebert94]</a>.
</p>

<p>
The simple form of turbulence shown above works quite well a lot of 
the time. However, the frequency is fixed and this can cause to shader
to alias or lack enough detail at different scales. The best technique
is to use a turbulence function which uses <i>gradual clamping</i>
like the code fragment below adapted from 
<a href="../references.html">[Ebert94]</a>.

<pre>
width = filterwidth_point(P);
cutoff = clamp(0.5 / width, 0, maxfreq);

turb = 0;
for (f = 1; f < 0.5 * cutoff; f *= 2) 
  turb += abs(snoise(P * f)) / f;

fade = clamp(2 * (cutoff - f) / cutoff, 0, 1);
turb += fade * abs(snoise(P * f)) / f;
</pre>

<p>
Gradual clamping limits the highest frequency component to one-half
the sampling rate and fades in the last noise component so that we
don't get "popping" as gradual changes in scale suddenly include or
exclude individual noise components. Note that the <i>maxfreq</i>
variable still exists, but it is now used as an upper limit 
to avoid "wasting time computing eleventy-jillion octaves of noise
when we get really close" as Rick Sayre aptly put it in
<a href="../references.html">[Apodaca92]</a>.
<code>filterwidth_point()</code> is provided in 
<a href="../rmannotes.sl">rmannotes.sl</a>.
</p>

<p><img src="black_line.gif"></p>
<p>
<a href="noise.html">previous</a>
|
<a href="pure.html">next</a>
|
<a href="index.html">stochastic patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 4/16/96</i></small></p>

</body>
</html>
